/********************************** <lalVerbatim file="COHFinalizeSearchCV">
Author: Julien Sylvestre
$Id: FinalizeSearch.c,v 1.3 2002/12/02 17:42:31 julien Exp $
**************************************************** </lalVerbatim> */

#include <lal/LALStdlib.h>
#include <lal/TFClusters.h>
#include <lal/CoherentEstimation.h>
#include <FinalizeSearch.h>
#include <InitSearch.h>
#include <lal/AVFactories.h>

NRCSID( FINALIZESEARCHC, "tfclusters $Id: FinalizeSearch.c,v 1.3 2002/12/02 17:42:31 julien Exp $" );

void
LALFinalizeSearch(
    LALStatus             *status,
    void                 **searchParams
    )
{
  
  CohereSearchParams *params;

  INITSTATUS (status, "LALFinalizeSearch", FINALIZESEARCHC);
  ATTATCHSTATUSPTR (status);

  if ( !(*searchParams) ){
    ABORT( status, FINALIZESEARCHH_ENULL, FINALIZESEARCHH_MSGENULL );
  }
  params = (CohereSearchParams *) *searchParams;

  if(params->dir) {
    LALFreeCListDir(status->statusPtr, params->dir);
    CHECKSTATUSPTR (status);
    LALFree(params->dir);
    params->dir = NULL;
  }

  LALClearCoherentData(status->statusPtr, &(params->IFOData));
  CHECKSTATUSPTR (status);

  LALClearCoherentInfo(status->statusPtr, &(params->IFOInfo));
  CHECKSTATUSPTR (status);

  LALFree(params->IFOIND);
  
  LALFree(params->Alpha);
  LALFree(params->Delta);
  LALFree(params->Psi);
  LALFree(params->plus2cross);
  LALFree(params->plusDotcross);
  
  LALFree(*searchParams);
  *searchParams = NULL;

  DETATCHSTATUSPTR (status);
  RETURN (status);
  
}
